package com.qq.taf.net;

/**
 * 伪执行器
 * @author fanzhang
 */
public class HandlerPseudoExecutor extends HandlerExecutor {
	
	private Handler handler;

	public HandlerPseudoExecutor(Handler handler) {
		this.handler=handler;
	}
	
	@Override
	public void sessionOpened(Session session) {
		try {
			handler.sessionOpened(session);
		} catch(Throwable t) {
			exceptionCaught(session, t);
		}
	}
	
	@Override
	public void sessionClosed(Session session) {
		try {
			handler.sessionClosed(session);
		} catch(Throwable t) {
			exceptionCaught(session, t);
		} 
	}
	
	@Override
	public void messageRecieved(Session session, Object message) {
		try {
			handler.messageRecieved(session, message);
		} catch(Throwable t) {
			exceptionCaught(session, t);
		}
	}
	
	@Override
	public void exceptionCaught(Session session, Throwable exception) {
		try {
			Logger.log("common caught error",exception);
			handler.exceptionCaught(session, exception);
		} catch(Throwable tt) {
			Logger.log("handler exceptionCaught error",tt);
		}
	}
	
}
