package com.qq.taf.net;

/**
 * 简单同步器
 * @author fanzhang
 */
public class ObjectSynchronizer<T> {
	
	private T obj;
	
	public void init() {
		obj=null;
	}
	
	public void put(T obj) {
		synchronized(this) {
			this.obj=obj;
			notifyAll();
		}
	}
	
	public T get(long timeout) {
		if(obj==null) {
			synchronized (this) {
				if(obj==null) {
					try {
						wait(timeout);
					} catch(InterruptedException ie) {
					}
				}
			}
		}
		T objCopy=obj;
		obj=null;
		return objCopy;
	}
	
}