package com.qq.taf.net.file;

import com.qq.taf.net.Acceptor;
import com.qq.taf.net.Exception;
import com.qq.taf.net.MessageReceiver;
import com.qq.taf.net.Handler;
import com.qq.taf.net.HandlerExecutor;
import com.qq.taf.net.HandlerPseudoExecutor;
import com.qq.taf.net.Logger;
import com.qq.taf.net.Processor;
import com.qq.taf.net.file.NetProcessor;

public class NetAcceptor extends Acceptor {
	private NetFilter filter;
	public NetAcceptor(String name, NetFilter filter, Handler handler,
			int netThreads, int handleThreads) {
		super(name, filter, handler, netThreads, handleThreads);
		this.filter = filter;
	}
	

	public synchronized void listen() {
		try {
			started=true;
			
			HandlerExecutor handlerExecutor=handleThreads>=0?new HandlerExecutor(name,handleThreads,handler):new HandlerPseudoExecutor(handler);
			NetFilterEncodeProduct filterEncodeProduct=new NetFilterEncodeProduct();
			MessageReceiver filterDecodeProduct=new MessageReceiver(handlerExecutor);
			
			int processorCount=netThreads>0?netThreads:Runtime.getRuntime().availableProcessors()+1;
			processors=new Processor[processorCount];
			for(int i=0;i<processorCount;i++) processors[i]=new NetProcessor(name,filter,filterEncodeProduct,filterDecodeProduct,handlerExecutor,i);
			new Thread(this,name+"-Acceptor").start();
		} catch(Throwable t) {
			Logger.log("netacceptor listen error",t);
			Exception.raise(t);
		}
	}
}
