package com.qq.taf.net.file;

import java.nio.ByteBuffer;
import java.nio.channels.WritableByteChannel;

public class NetByteBuffer implements NetDataBuffer {
	
	private ByteBuffer buffer;
	
	public NetByteBuffer(ByteBuffer buf) {
		this.buffer = buf;
	}
	
	@Override
	public boolean hasRemaining() {
		return buffer == null? false: buffer.hasRemaining();
	}

	@Override
	public long write(WritableByteChannel target) throws Throwable {
		return target.write(buffer);
	}

	@Override
	public long remaining() {
		return buffer.remaining();
	}

	@Override
	public void close() {
		
	}

}
