package com.qq.taf.net.file;

import com.qq.taf.net.Connector;
import com.qq.taf.net.MessageReceiver;
import com.qq.taf.net.Handler;
import com.qq.taf.net.HandlerExecutor;
import com.qq.taf.net.HandlerPseudoExecutor;
import com.qq.taf.net.Processor;

public class NetConnector extends Connector {
	
	private NetFilter filter;
	
	public NetConnector(String name, NetFilter filter, Handler handler,
			int netThreads, int handleThreads) {
		super(name, filter, handler, netThreads, handleThreads);
		this.filter = filter;
	}

	protected void init() {
		if(!started) {
			synchronized (this) {
				if(!started) {
					HandlerExecutor handlerExecutor=handleThreads>=0?new HandlerExecutor(name,handleThreads,handler):new HandlerPseudoExecutor(handler);
					NetFilterEncodeProduct filterEncodeProduct=new NetFilterEncodeProduct();
					MessageReceiver filterDecodeProduct=new MessageReceiver(handlerExecutor);
					
					int processorCount=netThreads>0?netThreads:Runtime.getRuntime().availableProcessors()+1;
					processors=new Processor[processorCount];
					for(int i=0;i<processorCount;i++) processors[i]=new NetProcessor(name,filter,filterEncodeProduct,filterDecodeProduct,handlerExecutor,i);
					
					started=true;
				}
			}
		}
	}
}
