package com.qq.taf.net.file;

import java.nio.channels.WritableByteChannel;

import com.qq.taf.net.Session;

public interface NetDataBuffer {
	
	public static final NetByteBuffer CLOSE_DATA = new NetByteBuffer(Session.CLOSE_FLAG);
	/**
	 * 是否有写剩余
	 * @return
	 */
	public boolean hasRemaining();
	
	
	/**
	 * 向目标Channel写入数据
	 * @param target 
	 * @return 写入字节数
	 */
	public long write(WritableByteChannel target) throws Throwable;
	
	
	/**
	 * 剩余字节数，未写入时，则取到的为总长度
	 * @return
	 */
	public long remaining();
	
	/**
	 * 销毁操作
	 */
	public void close() throws Throwable;
	
}
