package com.qq.taf.net.file;

import java.nio.channels.WritableByteChannel;


public class NetMixBuffer implements NetDataBuffer {
	private NetByteBuffer buffer;
	
	private NetFileBuffer file;
	
	public NetMixBuffer(NetByteBuffer buffer, NetFileBuffer file) {
		this.buffer = buffer;
		this.file = file;
	}
	@Override
	public boolean hasRemaining() {
		return buffer.hasRemaining()|| file.hasRemaining();
	}

	@Override
	public long write(WritableByteChannel target) throws Throwable {
		if(buffer.hasRemaining()) {
			return buffer.write(target);
		}
		else if(file.hasRemaining()) {
			return file.write(target);
		}
		return 0L;
	}
	@Override
	public long remaining() {
		return buffer.remaining()+file.remaining();
	}
	
	@Override
	public void close() throws Throwable {
		buffer.close();
		file.close();
	}

}
