package com.qq.taf.net.udp;

import java.nio.channels.DatagramChannel;

import com.qq.taf.proxy.TafLoggerCenter;

public class DefaultConfig implements Config {
	//MTU
	private final int MTU = 4*1024;
	
	private int receiveBufferSize = MTU;
	//一次一个端口最多发送字节数，防止缓冲区满
	private final int MaxSumSendLen = 64512*2/3;
	
	@Override
	public int getMTU() {
		return MTU;
	}

	@Override
	public int getMaxSumSendLen() {
		return MaxSumSendLen;
	}

	@Override
	public void configDatagramChannel(DatagramChannel dc) throws Throwable{
		if(dc == null) return;
		dc.configureBlocking(false);
		dc.socket().setReuseAddress(false);
		try {
			dc.socket().setReceiveBufferSize(receiveBufferSize);
		}
		catch (IllegalArgumentException ex) {
			TafLoggerCenter.info("configDatagramChannel() receiveBufferSize:" + receiveBufferSize + " IllegalArgumentException");
			throw ex;
		}
	}

	@Override
	public void setReceiveBufferSize(int size) {
		this.receiveBufferSize = size;
	}

}
