package com.qq.taf.proxy;

import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

import com.qq.taf.StatFPrxHelper;

/**
 * 
 * <b>功能：统计线程</b><br>
 * <br>
 * <b>完整路径：</b> com.qq.taf.proxy.StatThread <br>
 * <b>创建日期：</b> 2013-4-19 下午2:52:27 <br>
 * 
 * @author <a href="mailto:markzhang@tencent.com">markzhang</a><br>
 *         <a href="http://www.tencent.com">Shenzhen Tencent Co.,Ltd.</a>
 * @version 1.0, 2013-4-19
 * @since MQzone V1.0
 */
public class ProxyStatThread implements Runnable
{
	private static ProxyStatThread instance = new ProxyStatThread();
	
	private int runCount = 0;
	private StatFPrxHelper selfStatPrxPrx;
	
	private ProxyStatThread() {		
	}

	public static ProxyStatThread getInstance() {
		return instance;
	}
	
	public void init(StatFPrxHelper statPrxPrx) {
		if(statPrxPrx != null) {
			this.selfStatPrxPrx = statPrxPrx;
		}
	}

	public void run() {
		try {
			long begin = System.currentTimeMillis();
			runCount++;
			boolean report = false ;
			ConcurrentHashMap<ServantProxy, ProxyStatInfo> proxyStat = ProxyStatManager.getInstance().getProxyStats();
			for (Entry<ServantProxy, ProxyStatInfo> entry : proxyStat.entrySet()) {
				ServantProxy proxy = entry.getKey();
				StatFPrxHelper statPrxPrx = proxy.getStatPrxPr();
				
				// doPing
				if (runCount % 6 == 0) {
					runCount = 0;
					report = true ;
					proxy.checkSampleMap();
					if (null != statPrxPrx) {
						try {
							// Proxy的模块调用信息统计区间
							ProxyStatManager.getInstance().getStatTool(proxy).doReportStat(statPrxPrx);;
						} catch (Exception e) {
							TafLoggerCenter.error("ReportStatWorker reportStatMsg error objectName " + proxy.prxConfig.objectName, e);
						}
						try {
							// Proxy的样本信息统计区间
							ProxyStatManager.getInstance().doSample(proxy);
						} catch (Exception e) {
							TafLoggerCenter.error("ReportStatWorker reportSampleMsg error objectName " +  proxy.prxConfig.objectName, e);
						}
					}
					else {
						TafLoggerCenter.info("statPrxPrx is null, have no need to stat for "+proxy.prxConfig.objectName);
					}
				}
			}
			if ( report ) {
				if (null != selfStatPrxPrx) {
					try {
						// 单独调用上报接口填入的信息
						ProxyStatManager.getInstance().getDefaultStatTool().doReportStat(selfStatPrxPrx);
					} catch (Exception e) {
						TafLoggerCenter.error("ReportStatWorker error objectName ", e);
					}
				} else if (ProxyStatManager.getInstance().getDefaultStatSize() > 0 ) {
					TafLoggerCenter.info("statPrxPrx is null, have no need to stat for custom stat");
				}
			}
			TafLoggerCenter.info("ProxyStatTool run(), use: " + (System.currentTimeMillis() - begin));			
		} catch (Exception e) {
			TafLoggerCenter.error("ReportStatWorker error " + e, e);
		}
	}

}
