package com.qq.taf.proxy.utils;

import com.qq.taf.proxy.TafLoggerCenter;

/**
 * 时间戳生成器
 * @author fanzhang
 */
public class TimeProvider {

	private volatile long current;
	
	public TimeProvider(String name,int sleepIntervalMillis) {
		current=System.currentTimeMillis();
		final int fSleepInterval=sleepIntervalMillis;
		final String fThreadName="TimeProvider_"+name;
		new Thread(new Runnable() {
			public void run() {
				while(true) {
					current=System.currentTimeMillis();
					try {
						Thread.sleep(fSleepInterval);
					} catch(Throwable t) {
						TafLoggerCenter.error("TimeProvider thread error", t);
					}
				}
			}
		},fThreadName).start();	
	}
	
	public long currentTimeMillis() {
		return current;
	}
	
	public static void main(String... args) throws Throwable {
		TimeProvider tp=new TimeProvider("test",100);
		for(int i=0;i<100;i++) {
			System.out.println(tp.currentTimeMillis());
			Thread.sleep(30);
		}
	}
	
}
